#include<iostream>
#include<vector>
using namespace std;
int N,Q,sum[100000],parent[100000],a1[100000];
bool a[100000];
void f(int m){
    if(parent[m]!=0){
        if(a1[parent[m]]<a1[m]+1){
            a1[parent[m]]=a1[m]+1;
        }
        f(parent[m]);
    }
}
int main(){
    int m,n;
    cin>>N;
    for(int i=1;i<N;i++){
        cin>>m>>n;
        parent[n]=m;
        a[m]=true;
    }
    for(int i=1;i<=N;i++){
        if(a[i]==false){
            f(i);
        }
        if(parent[i]==0){
            n=i;
        }
    }
    for(int i=0;i<=a1[n];i++){
        for(int j=1;j<=N;j++){
            if(a1[j]==i){
                sum[parent[j]]+=sum[j]+1;
            }
        }
    }
    cin>>Q;
    for(int i=0;i<Q;i++){
        cin>>m;
        cout<<sum[m]<<endl;
    }
return 0;
}
